
/*  A Bison parser, made from macro.y
 by  GNU Bison version 1.2.7
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	TOKEN_IDENTIFIER	257
#define	TOKEN_MACRO	258
#define	TOKEN_ENDMACRO	259
#define	TOKEN_IMMEDIATE	260
#define	TOKEN_PARAM	261
#define	TOKEN_NEWLINE	262
#define	TOKEN_COMMA	263
#define	TOKEN_INCLUDE	264
#define	TOKEN_NUMBER	265
#define	TOKEN_EQUATE	266
#define	TOKEN_DOLLAR	267
#define	TOKEN_DOLLAR_EX	268
#define	TOKEN_INDIRECT	269
#define	TOKEN_CODE	270
#define	TOKEN_LOCAL	271
#define	TOKEN_END	272
#define	TOKEN_AND	273
#define	TOKEN_OR	274
#define	TOKEN_SHL	275
#define	TOKEN_SHR	276
#define	TOKEN_HIGH	277
#define	TOKEN_LOW	278
#define	TOKEN_NOT	279
#define	TOKEN_SEGMENT	280
#define	TOKEN_SEGMENT_TYPE	281
#define	TOKEN_SEGMENT_SELECT	282
#define	TOKEN_AT	283
#define	TOKEN_RSEG	284
#define	TOKEN_ORG	285
#define	TOKEN_BIT	286
#define	TOKEN_IF	287
#define	TOKEN_ELSE	288
#define	TOKEN_ENDIF	289
#define	TOKEN_MIN	290
#define	TOKEN_MAX	291


/***************************************************************************/
/*************************** begin yacc declarations ***********************/
/***************************************************************************/

#include "macro.h"

int yyparse (void);
int yyerror (char *mesg);
void InitConditionalStack(void);
void PushConditional(void);
void PopConditional(void);

extern  BOOL  InsertMacro();
extern  void  InitMacros();
extern  void  FreeMacros();
extern  BOOL  InsertEquate();
extern  void  InitEquates();
extern  void  FreeEquates();
extern  void  SetIncludePath(char *l_lpIncludePath);

#ifndef WIN32

#define SOLARIS
#ifdef SOLARIS // these values were pulled out of the air -> Find out the
               // true values NOW!!!
#define _MAX_PATH   255 /* max. length of full pathname */
#define _MAX_DRIVE  3   /* max. length of drive component */
#define _MAX_DIR    255 /* max. length of path component */
#define _MAX_FNAME  256 /* max. length of file name component */
#define _MAX_EXT    256 /* max. length of extension component */
#endif /* SOLARIS */
#endif /* !WIN32 */

#define WILDCARDS 0x01
#define EXTENSION 0x02
#define FILENAME  0x04
#define DIRECTORY 0x08
#define DRIVE     0x10

extern  FILE    *yyin,
                *g_lpOutFile,
                *g_lpTempOutFile;
extern  int     g_LineNumber;
extern  int     g_ExpressionValue;
extern  char    *yytext;
extern  char    g_LabelPrefix[80];
extern  char    g_TempString[260];
extern  BOOL    g_KillEnd;
extern  BOOL    g_InMacro;
extern  BOOL    g_InEquate;
extern  BOOL    g_HaveBitDigit;
extern  BOOL    g_InIncludeFile;
extern  int     g_NumberToResolve;
extern  MACRO   g_CurrentMacro;
extern  EQUATE  g_CurrentEquate;
extern  void    *g_lpVoidPtr;
extern  fpos_t  g_ExpressionPosition;

extern  LPREFERENCE_LIST  g_lpHoldReference;

int           g_BytesRead;
unsigned char g_TempBuff[1024];
BOOL          g_EndOfFile     = FALSE;
BOOL          g_BooleanIsTrue = FALSE;
BOOL          g_InExclusion   = FALSE;
BOOL          g_PICMode       = FALSE;
BOOL          g_GenerateDebugInfo  = FALSE;
CONDITIONAL_TABLE g_ConditionalStack;


extern  void        InitIncludeStack(void);
extern  BOOL        PushIncludeFile(char* p_lpFileName);
extern  BOOL        PopIncludeFile(void);
extern  const char  *GetCurrentFileName(void);
extern  FILE        *GetRootFile(void);

/*************************** end my yacc declarations **********************/
/***************************************************************************/

#ifndef YYSTYPE
#define YYSTYPE int
#endif
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		145
#define	YYFLAG		-32768
#define	YYNTBASE	50

#define YYTRANSLATE(x) ((unsigned)(x) <= 291 ? yytranslate[x] : 72)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    45,     2,     2,     2,     2,     2,     2,    42,
    43,    40,    38,     2,    39,     2,    41,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    47,
    44,    46,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    48,     2,    49,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     3,     5,     7,     9,    11,    13,    15,    17,
    20,    23,    26,    30,    32,    35,    38,    41,    42,    45,
    52,    56,    60,    65,    67,    69,    73,    78,    82,    86,
    91,    96,    97,   100,   104,   107,   109,   111,   114,   117,
   119,   121,   122,   125,   128,   129,   132,   135,   137,   139,
   143,   147,   151,   155,   159,   163,   167,   171,   176,   181,
   186,   193,   200,   204,   206,   210,   213,   215,   218,   222,
   226,   229,   232,   235,   238
};

static const short yyrhs[] = {    -1,
    18,     0,    53,     0,     8,     0,    54,     0,    55,     0,
    56,     0,    57,     0,    16,     0,     3,    32,     0,     3,
    70,     0,     3,    71,     0,     3,    26,    27,     0,    51,
     0,    30,     3,     0,    31,    67,     0,    28,    52,     0,
     0,    29,    67,     0,     3,     4,    61,    59,    65,     5,
     0,     3,    12,    68,     0,     3,    12,     3,     0,    33,
    42,    58,    43,     0,    34,     0,    35,     0,    68,    44,
    68,     0,    68,    45,    44,    68,     0,    68,    46,    68,
     0,    68,    47,    68,     0,    68,    46,    44,    68,     0,
    68,    47,    44,    68,     0,     0,    17,    60,     0,     3,
     9,    60,     0,     3,     8,     0,     8,     0,    62,     0,
     7,    63,     0,     3,    64,     0,     8,     0,    63,     0,
     0,     3,    66,     0,     8,    65,     0,     0,    70,    65,
     0,    71,    65,     0,    68,     0,    69,     0,    68,    38,
    68,     0,    68,    39,    68,     0,    68,    40,    68,     0,
    68,    41,    68,     0,    68,    19,    68,     0,    68,    20,
    68,     0,    68,    22,    68,     0,    68,    21,    68,     0,
    23,    42,    68,    43,     0,    24,    42,    68,    43,     0,
    25,    42,    68,    43,     0,    36,    42,    68,     9,    68,
    43,     0,    37,    42,    68,     9,    68,    43,     0,    42,
    68,    43,     0,    11,     0,    48,    68,    49,     0,     9,
    71,     0,     8,     0,     3,    70,     0,    41,     3,    70,
     0,    41,    67,    70,     0,     6,    70,     0,    15,    70,
     0,    13,    70,     0,    14,    70,     0,    67,    70,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   330,   335,   341,   346,   351,   356,   361,   366,   371,   376,
   381,   386,   391,   396,   401,   406,   413,   417,   418,   422,
   429,   448,   464,   489,   495,   512,   521,   530,   539,   548,
   557,   568,   569,   573,   575,   579,   581,   585,   589,   599,
   601,   605,   606,   608,   612,   613,   615,   619,   699,   704,
   706,   708,   710,   717,   719,   721,   723,   725,   727,   729,
   731,   733,   735,   739,   744,   755,   757,   761,   763,   765,
   767,   769,   771,   773,   775
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","TOKEN_IDENTIFIER",
"TOKEN_MACRO","TOKEN_ENDMACRO","TOKEN_IMMEDIATE","TOKEN_PARAM","TOKEN_NEWLINE",
"TOKEN_COMMA","TOKEN_INCLUDE","TOKEN_NUMBER","TOKEN_EQUATE","TOKEN_DOLLAR","TOKEN_DOLLAR_EX",
"TOKEN_INDIRECT","TOKEN_CODE","TOKEN_LOCAL","TOKEN_END","TOKEN_AND","TOKEN_OR",
"TOKEN_SHL","TOKEN_SHR","TOKEN_HIGH","TOKEN_LOW","TOKEN_NOT","TOKEN_SEGMENT",
"TOKEN_SEGMENT_TYPE","TOKEN_SEGMENT_SELECT","TOKEN_AT","TOKEN_RSEG","TOKEN_ORG",
"TOKEN_BIT","TOKEN_IF","TOKEN_ELSE","TOKEN_ENDIF","TOKEN_MIN","TOKEN_MAX","'+'",
"'-'","'*'","'/'","'('","')'","'='","'!'","'>'","'<'","'['","']'","Start","SegSelection",
"SegAddress","Macro","Equate","Conditional","ConditionalElse","ConditionalEndIf",
"Boolean","LocalList","Locals","ParamList","Params","ParamEntry","ParamEntryNext",
"MacroBody","MacroEntry","ProcessExpression","Expression","PicExpression","CodeEntry",
"CodeEntryNext", NULL
};
#endif

static const short yyr1[] = {     0,
    50,    50,    50,    50,    50,    50,    50,    50,    50,    50,
    50,    50,    50,    50,    50,    50,    51,    52,    52,    53,
    54,    54,    55,    56,    57,    58,    58,    58,    58,    58,
    58,    59,    59,    60,    60,    61,    61,    62,    63,    64,
    64,    65,    65,    65,    66,    66,    66,    67,    67,    68,
    68,    68,    68,    68,    68,    68,    68,    68,    68,    68,
    68,    68,    68,    68,    69,    70,    70,    71,    71,    71,
    71,    71,    71,    71,    71
};

static const short yyr2[] = {     0,
     0,     1,     1,     1,     1,     1,     1,     1,     1,     2,
     2,     2,     3,     1,     2,     2,     2,     0,     2,     6,
     3,     3,     4,     1,     1,     3,     4,     3,     3,     4,
     4,     0,     2,     3,     2,     1,     1,     2,     2,     1,
     1,     0,     2,     2,     0,     2,     2,     1,     1,     3,
     3,     3,     3,     3,     3,     3,     3,     4,     4,     4,
     6,     6,     3,     1,     3,     2,     1,     2,     3,     3,
     2,     2,     2,     2,     2
};

static const short yydefact[] = {     1,
     0,     4,     9,     2,    18,     0,     0,     0,    24,    25,
    14,     3,     5,     6,     7,     8,     0,     0,     0,    67,
     0,    64,     0,     0,     0,     0,     0,     0,     0,     0,
    10,     0,     0,     0,     0,     0,     0,    48,    49,    11,
    12,     0,    17,    15,    16,     0,    68,     0,    36,    32,
    37,    71,    66,    22,    21,    73,    74,    72,     0,     0,
     0,    13,     0,     0,     0,     0,     0,     0,    75,     0,
     0,     0,     0,     0,     0,     0,     0,    19,     0,     0,
     0,    38,     0,    42,     0,     0,     0,     0,     0,    69,
    70,    63,    65,    54,    55,    57,    56,    50,    51,    52,
    53,    23,     0,     0,     0,     0,    40,    41,    39,     0,
    33,    45,    42,     0,    58,    59,    60,     0,     0,    26,
     0,     0,    28,     0,    29,    35,     0,    43,    42,    42,
    44,    20,     0,     0,    27,    30,    31,    34,    46,    47,
    61,    62,     0,     0,     0
};

static const short yydefgoto[] = {   143,
    11,    43,    12,    13,    14,    15,    16,    79,    84,   111,
    50,    51,    82,   109,   114,   128,    37,    38,    39,    40,
    41
};

static const short yypact[] = {   230,
   100,-32768,-32768,-32768,   -18,     3,    49,   -25,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,    12,    18,    12,-32768,
   156,-32768,   183,    12,    12,    12,    -9,    17,    19,    -5,
-32768,    20,    26,    21,   255,   255,    12,   371,-32768,-32768,
-32768,    49,-32768,-32768,-32768,   255,-32768,    67,-32768,    54,
-32768,-32768,-32768,-32768,   371,-32768,-32768,-32768,   255,   255,
   255,-32768,   255,   255,    12,    12,   297,   262,-32768,   255,
   255,   255,   255,   255,   255,   255,   255,-32768,    32,   268,
     0,-32768,    73,     2,   303,   309,   334,   231,   235,-32768,
-32768,-32768,-32768,     8,    13,    55,-32768,    98,    98,    45,
    45,-32768,   255,    35,   190,   199,-32768,-32768,-32768,    34,
-32768,   141,     2,    76,-32768,-32768,-32768,   255,   255,   371,
   255,   255,   371,   255,   371,-32768,    73,-32768,     2,     2,
-32768,-32768,   340,   346,   371,   371,   371,-32768,-32768,-32768,
-32768,-32768,    78,    84,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   -40,
-32768,-32768,     7,-32768,  -111,-32768,    -3,   -23,-32768,   -10,
   -20
};


#define	YYLAST		412


static const short yytable[] = {    55,
    53,   131,    81,    45,   112,    44,    47,   107,    52,   113,
    42,    67,    68,    56,    57,    58,    46,   139,   140,    20,
    21,    62,    80,    65,    48,    49,    69,    71,    72,    73,
    66,    22,    59,    72,    73,    85,    86,    87,    78,    88,
    89,   126,   127,    27,    28,    29,    94,    95,    96,    97,
    98,    99,   100,   101,    90,    91,    32,    33,    60,    22,
    61,    63,    35,    70,    71,    72,    73,    64,    36,    81,
    83,    27,    28,    29,   102,   110,    73,   144,   121,   120,
   132,   123,   125,   145,    32,    33,   138,   108,     0,     0,
    35,   130,     0,     0,   133,   134,    36,   135,   136,     0,
   137,   129,    17,    18,     0,    19,     0,    20,    21,     0,
    22,    23,    24,    25,    26,     0,    70,    71,    72,    73,
     0,     0,    27,    28,    29,    30,     0,     0,     0,     0,
     0,    31,     0,     0,     0,    32,    33,    76,    77,     0,
    34,    35,     0,    17,     0,     0,    19,    36,    20,    21,
     0,    22,     0,    24,    25,    26,     0,     0,    17,     0,
     0,    19,     0,    27,    28,    29,    22,     0,    24,    25,
    26,     0,     0,     0,     0,     0,    32,    33,    27,    28,
    29,    34,    35,     0,     0,    54,     0,     0,    36,     0,
     0,    32,    33,    22,     0,     0,    34,    35,     0,     0,
    22,     0,     0,    36,     0,    27,    28,    29,     0,    22,
     0,     0,    27,    28,    29,     0,     0,     0,    32,    33,
     0,    27,    28,    29,    35,    32,    33,     0,     0,     0,
     0,    35,     1,   122,    32,    33,     0,     2,     0,   118,
    35,     0,   124,   119,     0,     3,     0,     4,     0,    70,
    71,    72,    73,    70,    71,    72,    73,     5,     0,     6,
     7,     0,     8,     9,    10,    22,     0,     0,    74,    75,
    76,    77,    74,    75,    76,    77,     0,    27,    28,    29,
    70,    71,    72,    73,     0,     0,    70,    71,    72,    73,
    32,    33,     0,     0,     0,     0,    35,     0,     0,    74,
    75,    76,    77,     0,     0,    74,    75,    76,    77,     0,
    93,   103,   104,   105,   106,    70,    71,    72,    73,     0,
     0,    70,    71,    72,    73,     0,     0,    70,    71,    72,
    73,     0,     0,     0,    74,    75,    76,    77,     0,    92,
    74,    75,    76,    77,     0,   115,    74,    75,    76,    77,
     0,   116,    70,    71,    72,    73,     0,     0,    70,    71,
    72,    73,     0,     0,    70,    71,    72,    73,     0,     0,
     0,    74,    75,    76,    77,     0,   117,    74,    75,    76,
    77,     0,   141,    74,    75,    76,    77,     0,   142,    70,
    71,    72,    73,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    74,    75,
    76,    77
};

static const short yycheck[] = {    23,
    21,   113,     3,     7,     3,     3,    17,     8,    19,     8,
    29,    35,    36,    24,    25,    26,    42,   129,   130,     8,
     9,    27,    46,     3,     7,     8,    37,    20,    21,    22,
    34,    11,    42,    21,    22,    59,    60,    61,    42,    63,
    64,     8,     9,    23,    24,    25,    70,    71,    72,    73,
    74,    75,    76,    77,    65,    66,    36,    37,    42,    11,
    42,    42,    42,    19,    20,    21,    22,    42,    48,     3,
    17,    23,    24,    25,    43,     3,    22,     0,    44,   103,
     5,   105,   106,     0,    36,    37,   127,    81,    -1,    -1,
    42,   112,    -1,    -1,   118,   119,    48,   121,   122,    -1,
   124,   112,     3,     4,    -1,     6,    -1,     8,     9,    -1,
    11,    12,    13,    14,    15,    -1,    19,    20,    21,    22,
    -1,    -1,    23,    24,    25,    26,    -1,    -1,    -1,    -1,
    -1,    32,    -1,    -1,    -1,    36,    37,    40,    41,    -1,
    41,    42,    -1,     3,    -1,    -1,     6,    48,     8,     9,
    -1,    11,    -1,    13,    14,    15,    -1,    -1,     3,    -1,
    -1,     6,    -1,    23,    24,    25,    11,    -1,    13,    14,
    15,    -1,    -1,    -1,    -1,    -1,    36,    37,    23,    24,
    25,    41,    42,    -1,    -1,     3,    -1,    -1,    48,    -1,
    -1,    36,    37,    11,    -1,    -1,    41,    42,    -1,    -1,
    11,    -1,    -1,    48,    -1,    23,    24,    25,    -1,    11,
    -1,    -1,    23,    24,    25,    -1,    -1,    -1,    36,    37,
    -1,    23,    24,    25,    42,    36,    37,    -1,    -1,    -1,
    -1,    42,     3,    44,    36,    37,    -1,     8,    -1,     9,
    42,    -1,    44,     9,    -1,    16,    -1,    18,    -1,    19,
    20,    21,    22,    19,    20,    21,    22,    28,    -1,    30,
    31,    -1,    33,    34,    35,    11,    -1,    -1,    38,    39,
    40,    41,    38,    39,    40,    41,    -1,    23,    24,    25,
    19,    20,    21,    22,    -1,    -1,    19,    20,    21,    22,
    36,    37,    -1,    -1,    -1,    -1,    42,    -1,    -1,    38,
    39,    40,    41,    -1,    -1,    38,    39,    40,    41,    -1,
    49,    44,    45,    46,    47,    19,    20,    21,    22,    -1,
    -1,    19,    20,    21,    22,    -1,    -1,    19,    20,    21,
    22,    -1,    -1,    -1,    38,    39,    40,    41,    -1,    43,
    38,    39,    40,    41,    -1,    43,    38,    39,    40,    41,
    -1,    43,    19,    20,    21,    22,    -1,    -1,    19,    20,
    21,    22,    -1,    -1,    19,    20,    21,    22,    -1,    -1,
    -1,    38,    39,    40,    41,    -1,    43,    38,    39,    40,
    41,    -1,    43,    38,    39,    40,    41,    -1,    43,    19,
    20,    21,    22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    38,    39,
    40,    41
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */


/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#elif defined (WIN32)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif



/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
{
                  //printf("\nSuccess\n");
                  return 0;
                ;
    break;}
case 2:
{
                  //printf(" \nDone\n");
                  g_EndOfFile = TRUE;
                  return 0;
                ;
    break;}
case 3:
{
                  //printf("\nStart1\n");
                  return 0;
                ;
    break;}
case 4:
{
                  //printf("\nStart2\n");
                  return 0;
                ;
    break;}
case 5:
{
                  //printf("\nStart3\n");
                  return 0;
                ;
    break;}
case 6:
{
                  //printf("Conditional\n");
                  return 0;
                ;
    break;}
case 7:
{
                  //printf("ConditionalElse\n");
                  //return 0;
                ;
    break;}
case 8:
{
                  //printf("ConditionalEnd\n");
                  return 0;
                ;
    break;}
case 9:
{
                  //printf("\nStart4\n");
                  return 0;
                ;
    break;}
case 10:
{
                  //printf("\nStart5\n");
                  return 0;
                ;
    break;}
case 11:
{
                  //printf("\nStart6\n");
                  return 0;
                ;
    break;}
case 12:
{
                  //printf("\nStart7\n");
                  return 0;
                ;
    break;}
case 13:
{
                  //printf("\nStart8\n");
                  return 0;
                ;
    break;}
case 14:
{
                  //printf("\nStart9\n");
                  return 0;
                ;
    break;}
case 15:
{
                  //printf("\nStart10\n");
                  return 0;
                ;
    break;}
case 16:
{
                  //printf("\nStart11\n");
                  return 0;
                ;
    break;}
case 17:
{;
    break;}
case 19:
{;
    break;}
case 20:
{ /* store macro in table */
                  //printf("Got a macro ");
                  InsertMacro();
                ;
    break;}
case 21:
{/* store equate in table */
                  if(g_InEquate)
                  {
                    if(g_HaveBitDigit)
                    {
                      g_CurrentEquate.Value = g_NumberToResolve;
                      g_HaveBitDigit = FALSE;

                    }
                    else
                      g_CurrentEquate.Value = yyvsp[0];

                    g_InEquate = FALSE;
                  }

                  //printf("Got an equate ");
                  InsertEquate();
                ;
    break;}
case 22:
{

                  g_CurrentEquate.Type = EQUATE_REFERENCE;
                  g_CurrentEquate.Reference = malloc(strlen(yytext)+1);

                  if(!g_CurrentEquate.Reference)
                    yyerror("Memory allocation error");

                  strcpy(g_CurrentEquate.Reference, yytext);
                  g_InEquate = FALSE;
                  //printf("Got an equate ");
                  InsertEquate();
                ;
    break;}
case 23:
{
//                  printf("Conditional %s\n",
//                    g_BooleanIsTrue? "TRUE": "FALSE");
PushConditional();
/*
                  if(!g_BooleanIsTrue)
                  {
                    g_InExclusion = TRUE;
                    
                    //  essentially we are going to pipe
                    //  the code that is not to be included
                    //  to a NULL output stream or to be
                    //  more precise a temporary output
                    //  stream that will be deleted
                    //
                    // save the valid stream 
                    g_lpTempOutFile = g_lpOutFile;
                    // create a new, temporary stream
                    g_lpOutFile = tmpfile();
                  }
*/
                ;
    break;}
case 24:
{
                  //printf("ConditionalElse \n");
                ;
    break;}
case 25:
{
//                  printf("ConditionalEnd \n");
PopConditional();
/*
                  if(g_InExclusion)
                  {
                    g_InExclusion = FALSE;
                    // close temporary stream 
                    fclose(g_lpOutFile);
                    // restore original stream 
                    g_lpOutFile = g_lpTempOutFile;
                  }
*/
                ;
    break;}
case 26:
{
//                  printf("Boolean( %d = %d)\n", $1,$3);

                  if(yyvsp[-2] == yyvsp[0])
                    g_BooleanIsTrue = TRUE;
                  else
                    g_BooleanIsTrue = FALSE;
                ;
    break;}
case 27:
{
                  //printf("Boolean( %d != %d )\n",$1,$4);

                  if(yyvsp[-3] != yyvsp[0])
                    g_BooleanIsTrue = TRUE;
                  else
                    g_BooleanIsTrue = FALSE;
                ;
    break;}
case 28:
{
                  //printf("Boolean( %d > %d )\n",$1,$3);

                  if(yyvsp[-2] > yyvsp[0])
                    g_BooleanIsTrue = TRUE;
                  else
                    g_BooleanIsTrue = FALSE;
                ;
    break;}
case 29:
{
                  //printf("Boolean( %d < %d )\n",$1,$3);

                  if(yyvsp[-2] < yyvsp[0])
                    g_BooleanIsTrue = TRUE;
                  else
                    g_BooleanIsTrue = FALSE;
                ;
    break;}
case 30:
{
                  //printf("Boolean( %d >= %d )\n",$1,$4);

                  if(yyvsp[-3] >= yyvsp[0])
                    g_BooleanIsTrue = TRUE;
                  else
                    g_BooleanIsTrue = FALSE;
                ;
    break;}
case 31:
{
                  //printf("Boolean( %d <= %d )\n",$1,$4);

                  if(yyvsp[-3] <= yyvsp[0])
                    g_BooleanIsTrue = TRUE;
                  else
                    g_BooleanIsTrue = FALSE;
                ;
    break;}
case 33:
{;
    break;}
case 34:
{;
    break;}
case 35:
{;
    break;}
case 36:
{;
    break;}
case 37:
{;
    break;}
case 38:
{;
    break;}
case 39:
{ /*
                   * add a parameter to the list
                   * this is not called until
                   * all the params are parsed
                   * add parms in lex!!!
                   */
                ;
    break;}
case 40:
{;
    break;}
case 41:
{;
    break;}
case 43:
{;
    break;}
case 44:
{;
    break;}
case 46:
{;
    break;}
case 47:
{;
    break;}
case 48:
{
                  //printf("PROCESSING EXPRESSION ");
                  if(g_InMacro)
                  {
                    if(!g_PICMode)
                      sprintf(g_TempString, "0%Xh", yyvsp[0]);
                    else
                      sprintf(g_TempString, "h0%X", yyvsp[0]);

                    g_lpHoldReference->Reference.Pointer =
                                  malloc(strlen(g_TempString)+1);
                    strcpy((char *)(g_lpHoldReference->Reference.Pointer),
                           g_TempString);
                  }
                  else if(g_InEquate)
                  {
                    g_CurrentEquate.Value = yyvsp[0];
                    g_InEquate = FALSE;
                  }
                  else
                  {
                    if(!g_InIncludeFile)
                    {
                      // we need to back up to the point where the
                      // expression started and insert the resolved
                      // number
                      fsetpos(g_lpOutFile, &g_ExpressionPosition);
                      g_BytesRead = fread(g_TempBuff, 1,
                                          sizeof(g_TempBuff), g_lpOutFile);
                      fsetpos(g_lpOutFile, &g_ExpressionPosition);

                      // this is a hack - it may not work for all cases
                      if((*g_TempBuff == ',') && (*yytext == ','))
                      {
                        if(!g_PICMode)
                          fprintf(g_lpOutFile, "0%Xh", yyvsp[0]);
                        else
                          fprintf(g_lpOutFile, "h0%X", yyvsp[0]);
                      }
                      else if((*g_TempBuff == '.') && (*yytext == ','))
                      {
                        if(!g_PICMode)
                          fprintf(g_lpOutFile, "0%Xh", yyvsp[0]);
                        else
                          fprintf(g_lpOutFile, "h0%X", yyvsp[0]);
                      }
                      else if((g_TempBuff[strlen(g_TempBuff)-1] == '\n') &&
                              (*yytext == '\n'))
                      {
                        if(!g_PICMode)
                          fprintf(g_lpOutFile, "0%Xh", yyvsp[0]);
                        else
                          fprintf(g_lpOutFile, "h0%X", yyvsp[0]);
                      }
                      else
                      {
                        while((*yytext == ' ') || (yytext == '\t'))
                          yytext++;

                        if((*g_TempBuff == ',') && (*yytext == ','))
                        {
                          if(!g_PICMode)
                            fprintf(g_lpOutFile, "0%Xh", yyvsp[0]);
                          else
                            fprintf(g_lpOutFile, "h0%X", yyvsp[0]);
                        }
                        else
                        {
                          if(!g_PICMode)
                            fprintf(g_lpOutFile, "0%Xh%s", yyvsp[0], yytext);
                          else
                            fprintf(g_lpOutFile, "h0%X%s", yyvsp[0], yytext);
                        }
                      }

                      fwrite(g_TempBuff, g_BytesRead, 1, g_lpOutFile);
                    }
                  }
                ;
    break;}
case 49:
{
                  fprintf(g_lpOutFile, "[h0%X]", yyvsp[0]);
                ;
    break;}
case 50:
{yyval = yyvsp[-2] + yyvsp[0];
    break;}
case 51:
{yyval = yyvsp[-2] - yyvsp[0];
    break;}
case 52:
{yyval = yyvsp[-2] * yyvsp[0];
    break;}
case 53:
{
                  if(yyvsp[0] == 0)
                    yyerror("Attempt to divide by zero");
                  else
                    yyval = yyvsp[-2] / yyvsp[0];
                ;
    break;}
case 54:
{yyval = yyvsp[-2] & yyvsp[0];
    break;}
case 55:
{yyval = yyvsp[-2] | yyvsp[0];
    break;}
case 56:
{yyval = yyvsp[-2] >> yyvsp[0];
    break;}
case 57:
{yyval = yyvsp[-2] << yyvsp[0];
    break;}
case 58:
{yyval = (yyvsp[-1] >> 8) & 0x0ff;
    break;}
case 59:
{yyval = yyvsp[-1] & 0x0ff;
    break;}
case 60:
{yyval = (~(yyvsp[-1]&0x0ffffff) & 0x0ffffff);
    break;}
case 61:
{yyval = (yyvsp[-3] < yyvsp[-1])? yyvsp[-3]: yyvsp[-1];
    break;}
case 62:
{yyval = (yyvsp[-3] > yyvsp[-1])? yyvsp[-3]: yyvsp[-1];
    break;}
case 63:
{
                  yyval = yyvsp[-1];
                ;
    break;}
case 64:
{
                  yyval = g_NumberToResolve;
                ;
    break;}
case 65:
{
                  if(g_PICMode)
                    yyval = yyvsp[-1];
                  else
                  {
                    sprintf(g_TempString,"Invalid Expression \"[%d]\"", yyvsp[-1]);
                    yyerror(g_TempString);
                  }
                ;
    break;}
case 66:
{;
    break;}
case 67:
{;
    break;}
case 68:
{;
    break;}
case 69:
{/* slash */;
    break;}
case 70:
{/* slash 2 */;
    break;}
case 71:
{;
    break;}
case 72:
{;
    break;}
case 73:
{;
    break;}
case 74:
{;
    break;}
case 75:
{;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */


  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}


/***********  Program Section  ***********/
/***************************************************************************/
/****************************** yacc entry point ***************************/
/***************************************************************************/
void static   SplitPath(const char *pathP,
                        char *driveP,
                        char *dirP,
                        char *nameP,
                        char *extP);

void  CloseOutputFile(void);
char  *g_FileName;
char  g_TempOutputFileName[_MAX_DIR];
char  g_OutputFileName[_MAX_DIR];
char  *g_Tmp;
char  g_OutputBuff[32768];

#define VERSION_MAJOR 0
#define VERSION_MINOR 300
#define BUILD "$Revision: 36 $"
/*
*/
void PrintBanner()
{
  char  l_lpBuild[] = BUILD;
  char  *l_lpTemp;

  fprintf(stderr,
#ifdef WIN32
           ""\
           "ͻ\n"
          " Dallas Semiconductor DS80C390 Macro Preprocessor, Beta Version %d.%03d.%04u \n"
          ""\
          "ͼ\n"
#else
          "+------------------------------------------------------------------"\
          "---------+\n"
          "| Dallas Semiconductor DS80C390 Macro Preprocessor, Beta Version %d.%03d.%04u |\n"
          "+------------------------------------------------------------------"\
          "---------+\n"
#endif
          "Last build %s at %s\n\n",
          VERSION_MAJOR,
          VERSION_MINOR,
          strtol(strtok(l_lpBuild,"evision: $R"), &l_lpTemp, 10),
          __DATE__,
          __TIME__);

}
/*
*/
void Usage(int p_ErrorCode)
{
  fprintf(stderr, "Usage:\tmacro [options] <input file>\n");
  fprintf(stderr, "\toptions:\n");
  fprintf(stderr, "\t-q\t\t\tquiet mode\n");
  fprintf(stderr, "\t-p\t\t\tUC03 mode\n");
  //fprintf(stderr, "\t-g\t\t\tgenerate line info\n"); // for debug use
  fprintf(stderr, "\t-e-\t\t\tstrip \"end\" statement\n");
  fprintf(stderr, "\t-I<Include Path>\toptional include file directory\n");
  fprintf(stderr, "\n");
  exit(p_ErrorCode);
}
/*
*/
int main(int argc, char *argv[])
{
  char  l_Drive[_MAX_DRIVE];
  char  l_Dir[_MAX_DIR];
  char  l_Name[_MAX_FNAME];
  char  l_Ext[_MAX_EXT];
  char  l_QuietMode = 0;
  int   l_Strlen;
  int   l_RetVal;
  int   l_Count = 0;
  int   i;
  char  *l_lpFilename = NULL;
  char  *l_lpIncludePath = NULL;

  if(argc < 2)
  {
    PrintBanner();
    Usage(0);
  }

  for(i = 1; i < argc; i++)
  {
    if(argv[i][0] != '-')
    {
      l_lpFilename = argv[i];
    }
    else
    {
      if(!strcmp(argv[i], "-E-"))
        g_KillEnd = TRUE;
      else if(!strcmp(argv[i], "-e-"))
        g_KillEnd = TRUE;
      else if(argv[i][1] == 'q')
        l_QuietMode = 1;
      else if(argv[i][1] == 'p')
        g_PICMode = 1;
      else if(argv[i][1] == 'g')
        g_GenerateDebugInfo = 1;
      else if(argv[i][1] == 'I')
      {
        l_lpIncludePath = argv[i]+2;
        SetIncludePath(l_lpIncludePath);
      }
      else
      {
        PrintBanner();
        fprintf(stderr, "Unrecognized switch \"%s\"\n\n", argv[i]);
        Usage(1);
      }
    }
  }

  SplitPath(l_lpFilename,
            l_Drive,
            l_Dir,
            l_Name,
            l_Ext);
  l_Strlen  = strlen(l_Name);
  memcpy(g_LabelPrefix, l_Name, l_Strlen);

  strcpy(g_OutputFileName, l_Name);
  strcat(g_OutputFileName, ".mpp");

  // this function reuses the filename buffer
  g_Tmp = tmpnam(NULL);
  // make a copy to prevent scroggage
  strcpy(g_TempOutputFileName, g_Tmp);

  remove(g_OutputFileName);

  if(!(g_lpOutFile = fopen(g_TempOutputFileName,"w+")))
  {
    PrintBanner();
    fprintf(stderr, "Unable to open the file %s\n", l_Dir);
    return 1;
  }

  if(!l_QuietMode)
    PrintBanner();

  setvbuf(g_lpOutFile, g_OutputBuff, _IOFBF, sizeof(g_OutputBuff));

  if(g_PICMode)
  {
    if(g_GenerateDebugInfo)
      fprintf(g_lpOutFile,";BEGIN_MODULE(%s)\n", l_lpFilename);
  }
  else
    fprintf(g_lpOutFile,"$BEGIN_MODULE(%s)\n", l_Name);

  if(!l_QuietMode)
  {
    fprintf(stderr,"Parsing %s...\n", l_lpFilename);

    if(g_PICMode)
      fprintf(stderr, "Using PIC syntax\n");

    if(g_KillEnd)
      fprintf(stderr, "Stripping END statement\n");

    if(g_GenerateDebugInfo)
      fprintf(stderr, "Generating debug line information\n");

    if(l_lpIncludePath)
      fprintf(stderr, "Adding include path \"%s\"\n", l_lpIncludePath);
  }

  g_FileName = l_lpFilename;
  InitMacros();
  InitEquates();
  InitIncludeStack();
  InitConditionalStack();

  if(!PushIncludeFile(g_FileName))
  {
    //printf("Error, Unable to open %s",l_lpFilename);
    return 2;
  }

//yydebug=1;

  do
  {
    if((l_RetVal = yyparse()))    /* parse a statement   */
    {
      break;
    }
/*
    switch((l_Count++)%4)
    {
      case 0:
        fprintf(stderr,"|\r");
      break;

      case 1:
        fprintf(stderr,"/\r");
      break;

      case 2:
        fprintf(stderr,"-\r");
      break;

      case 3:
        fprintf(stderr,"\\\r");
      break;
    }

    l_Count &= 3;
*/
  } while (!g_EndOfFile);

  fflush(stdout);

  if(l_RetVal)
    fprintf(stderr, " \nParser terminated with error\n");
  else
  {
    if(!l_QuietMode)
      fprintf(stderr, " \nParser terminated without error\n");
  }

  fflush(stderr);
  CloseOutputFile();
  FreeMacros();
  FreeEquates();
  remove(g_TempOutputFileName);

  return 0;
}
/***************************************************************************/
int yyerror (char *mesg)
{
  char *l_CurrentFileName = GetCurrentFileName();
  printf("\n%s: %s\n%*cLine %d. Last token read was \"%s\"\n",
         l_CurrentFileName,
         mesg, 
         strlen(l_CurrentFileName)+2,' ',
         g_LineNumber,
         yytext? yytext: "");

  CloseOutputFile();
  FreeMacros();
  FreeEquates();
  remove(g_OutputFileName);
  remove(g_TempOutputFileName);

  exit(1);
//  return 0;
}/* yyerror */
/***************************************************************************/
int yywrap ()
{
  if(PopIncludeFile())
      return 0;
/*
  if(g_lpOutFile)
  {
    fclose(g_lpOutFile);
    g_lpOutFile = NULL;
  }
*/
  g_EndOfFile = TRUE;
  FreeMacros();
  FreeEquates();
  remove(g_TempOutputFileName);

  return 0;
}/* yywrap */
/***************************************************************************/
/*
 */
void InitConditionalStack()
{
  memset(&g_ConditionalStack, 0, sizeof(g_ConditionalStack));
}
/***************************************************************************/
/*
 */
void PushConditional()
{
  if((g_ConditionalStack.StackPointer+1) == MAX_CONDITIONAL)
    yyerror("Maximum conditional stack exceeded");

  g_ConditionalStack.List[g_ConditionalStack.StackPointer].InExclusion = 
                                                             g_InExclusion;
  g_ConditionalStack.List[g_ConditionalStack.StackPointer].LineNumber = 
                                                          g_LineNumber;
  strcpy(g_ConditionalStack.List[g_ConditionalStack.StackPointer++].FileName,
         GetCurrentFileName());

  if(!g_InExclusion)
  {
    if(!g_BooleanIsTrue)
    {
      g_InExclusion = TRUE;
      /*
       * essentially we are going to pipe
       * the code that is not to be included
       * to a NULL output stream or to be
       * more precise a temporary output
       * stream that will be deleted
       */
      /* save the valid stream */
      g_lpTempOutFile = g_lpOutFile;
      /* create a new, temporary stream */
      g_lpOutFile = tmpfile();
    }
  }
}
/***************************************************************************/
/*
 */
void PopConditional()
{
  if((--g_ConditionalStack.StackPointer) < 0)
    yyerror("Found \"ENDIF with no matching \"IF\"");

  if(!g_ConditionalStack.List[g_ConditionalStack.StackPointer].InExclusion & 
     g_InExclusion)
  {
    g_InExclusion = FALSE;
    /* close temporary stream */
    fclose(g_lpOutFile);
    /* restore original stream */
    g_lpOutFile = g_lpTempOutFile;
  }

  g_InExclusion = 
     g_ConditionalStack.List[g_ConditionalStack.StackPointer].InExclusion;
}
/***************************************************************************/
/*
 * fsetpos doesn't resize the file and extra characters remain at the end of
 * the file. This function resizes the file in an ANSI C compatible fashion.
 */
#ifdef WIN32
#include<io.h>
void  CloseOutputFile(void)
{
  _chsize(fileno(g_lpOutFile),ftell(g_lpOutFile));
  fclose(g_lpOutFile);
  rename(g_TempOutputFileName, g_OutputFileName);
}
#else
void  CloseOutputFile(void)
{
  int     filelength(int);
  FILE   *l_lpTempFile;
  long    l_FilePos;
  char    *l_lpFileName = tmpnam(NULL);
  char    *l_lpBuff = NULL;
  size_t  l_BytesRead;
  long    l_Size = ftell(g_lpOutFile);

  if(!g_lpOutFile)
    return;

  if(!l_lpFileName)
  {
    fclose(g_lpOutFile);
    g_lpOutFile = NULL;
  }

  l_FilePos = ftell(g_lpOutFile);
  rewind(g_lpOutFile);
  l_lpTempFile = fopen(l_lpFileName,"w+");

  if(!l_lpFileName)
  {
    fclose(g_lpOutFile);
    g_lpOutFile = NULL;
  }

  if(!l_lpBuff)
    l_lpBuff = malloc(l_Size);

  if(!l_lpBuff)
  {
    l_Size = 32768;
    l_lpBuff = malloc(l_Size);
  }

  if(l_lpBuff)
  {

    while((long)(ftell(l_lpTempFile) + l_Size) < l_FilePos)
    {
      l_BytesRead = fread(l_lpBuff, 1,  l_Size,  g_lpOutFile);
      fwrite(l_lpBuff,  l_BytesRead,  1,  l_lpTempFile);
    }

    if((long)ftell(l_lpTempFile) < l_FilePos)
    {
      l_BytesRead = fread(l_lpBuff, 1,  l_Size,  g_lpOutFile);
      fwrite(l_lpBuff,  l_BytesRead,  1,  l_lpTempFile);
    }
/*
    while(fread(l_lpBuff, 1,  1,  g_lpOutFile))
    {
      fwrite(l_lpBuff,  1,  1,  l_lpTempFile);

      if(l_FilePos == ftell(l_lpTempFile))
      {
        break;
      }
    }
*/
    fclose(l_lpTempFile);
    fclose(g_lpOutFile);

    g_lpOutFile = fopen(g_OutputFileName,"w+");
    l_lpTempFile = fopen(l_lpFileName,"r");

    while((l_BytesRead = fread(l_lpBuff, 1, l_Size, l_lpTempFile)))
      fwrite(l_lpBuff, l_BytesRead, 1, g_lpOutFile);

    free(l_lpBuff);
  }

  fclose(l_lpTempFile);
  fclose(g_lpOutFile);
  remove(l_lpFileName);
  g_lpOutFile = NULL;
}
#endif
/***************************************************************************/
static void CopyIt(char *dst, const char *src, unsigned maxlen)/* Modified Borland C++ 3.1 code */
{                  /* for portability */
  if(dst)
  {
    if(strlen(src) >= maxlen)
    {
      strncpy(dst, src, maxlen);
      dst[maxlen] = 0;
    }
    else
      strcpy(dst, src);
  }
}
/***************************************************************************/
static int DotFound(char *pB)/* Modified Borland C++ 3.1 code */
{                            /* for portability */
  if(*(pB-1) == '.')
    pB--;

  switch (*--pB)
  {
    case ':'  :
      if(*(pB-2) != '\0')
        break;
    case '/'  :
    case '\\' :
    case '\0' :
    return 1;
  }

  return 0;
}
/***************************************************************************/
int FnSplit(const char *pathP,/* Modified Borland C++ 3.1 code */
            char *driveP,     /* for portability */
            char *dirP,
            char *nameP,
            char *extP)
{
  char   *pB;
  int    Wrk;
  int     Ret;
  char buf[_MAX_PATH+2];

  /*
    Set all strings to default value zero
  */
  Ret = 0;

  if(driveP)
    *driveP = 0;

  if(dirP)
    *dirP = 0;

  if(nameP)
    *nameP = 0;

  if(extP)
    *extP = 0;

  /*
    Copy filename into template up to _MAX_PATH characters
  */
  pB = buf;

  while (*pathP == ' ')
    pathP++;

  if((Wrk = strlen(pathP)) > _MAX_PATH)
    Wrk = _MAX_PATH;

  *pB++ = 0;
  strncpy(pB, pathP, Wrk);
  *(pB += Wrk) = 0;

  /*
    Split the filename and fill corresponding nonzero pointers
  */
  Wrk = 0;

  for (;;)
  {
    switch (*--pB)
    {
      case '.'  :
        if(!Wrk && (*(pB+1) == '\0'))
          Wrk = DotFound(pB);

        if((!Wrk) && ((Ret & EXTENSION) == 0))
        {
          Ret |= EXTENSION;
          CopyIt(extP, pB, _MAX_EXT - 1);
          *pB = 0;
        }
      continue;

      case ':'  :
        if(pB != &buf[2])
          continue;

      case '\0' :
        if(Wrk)
        {
          if(*++pB)
            Ret |= DIRECTORY;

          CopyIt(dirP, pB, _MAX_DIR - 1);
          *pB-- = 0;
          break;
        }

      case '/'  :
      case '\\' :
        if (!Wrk)
        {
          Wrk++;

          if (*++pB)
            Ret |= FILENAME;

          CopyIt(nameP, pB, _MAX_FNAME - 1);
          *pB-- = 0;

          if (*pB == 0 || (*pB == ':' && pB == &buf[2]))
            break;
        }
      continue;

      case '*'  :
      case '?'  :
        if (!Wrk)
          Ret |= WILDCARDS;

      default :
      continue;
    }
    break;
  }

  if(*pB == ':')
  {
    if(buf[1])
      Ret |= DRIVE;

    CopyIt(driveP, &buf[1], _MAX_DRIVE - 1);
  }

  return (Ret);
}
/***************************************************************************/
void static SplitPath(const char *pathP,/* Modified Borland C++ 3.1 code */
                      char *driveP,     /* for portability */
                      char *dirP,
                      char *nameP,
                      char *extP)
{
  (void)FnSplit(pathP,driveP,dirP,nameP,extP);
}

/***************************************************************************/
/***************************** end my yacc source **************************/
/***************************************************************************/
